extern char *malloc(), *realloc();

# line 2 "parser.y"

#include <stdio.h>
#include <string.h>
#include "parser.h"
#include "token.h"

#define MAX_ITEMS_PER_ALTERNATIVE 1024

char *builtin_type_name[] = {0, "int", "float", "char*"};
char *builtin_union_member[] = {0, "i", "f", "s"};

char *lhs;
int alt_counter;
int item_counter;
char member_flag[MAX_ITEMS_PER_ALTERNATIVE];


# line 20 "parser.y"
typedef union  {
	char *s;
	int i;
} YYSTYPE;
# define TOKEN 257
# define INT 258
# define FLOAT 259
# define CHAR 260
# define BAR 261
# define EQUALS 262
# define SEMI 263
# define DOLLAR 264
# define LBRACE 265
# define RBRACE 266
# define COLON 267
# define STAR 268
# define IDENT 269
# define PATTERN 270
# define INTEGER 271
# define CTOKEN 272
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 172 "parser.y"


#include "scanner.yy.c"
int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 12,
	267, 15,
	-2, 13,
	};
# define YYNPROD 35
# define YYLAST 57
int yyact[]={

    40,    20,    37,    43,    21,    20,    13,     7,    39,    35,
    36,    14,    18,    20,    28,    26,    27,    17,     9,    10,
    11,     5,    23,    38,    30,    19,    25,    33,    32,    29,
    24,    31,    16,    22,    15,    12,     6,     4,     3,     2,
     1,     8,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    42,    34,    41 };
int yypact[]={

 -1000, -1000,  -236,  -262, -1000,  -240, -1000, -1000,  -263, -1000,
 -1000,  -257, -1000,  -245, -1000,  -255,  -252,  -266, -1000, -1000,
 -1000,  -248,  -247, -1000, -1000, -1000, -1000, -1000, -1000,  -260,
  -264, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
  -268, -1000, -1000, -1000 };
int yypgo[]={

     0,    41,    40,    39,    38,    37,    36,    35,    34,    33,
    32,    25,    31,    22,    30,    29,    28,    27,    26,    24,
    23 };
int yyr1[]={

     0,     2,     3,     3,     5,     1,     1,     1,     1,     4,
     4,     7,     6,    10,     8,     8,    12,     9,     9,    14,
    13,    16,    16,    15,    15,    17,    17,    18,    11,    19,
    19,    20,    20,    20,    20 };
int yyr2[]={

     0,     4,     4,     0,    13,     3,     3,     5,     1,     4,
     0,     1,    13,     1,     5,     1,     1,     8,     2,     1,
     7,     2,     0,     4,     0,     3,     3,     1,     9,     4,
     0,     3,     5,     2,     0 };
int yychk[]={

 -1000,    -2,    -3,    -4,    -5,   257,    -6,   269,    -1,   258,
   259,   260,    -7,   269,   268,    -8,   -10,   262,   267,   -11,
   265,   270,    -9,   -13,   -14,   -18,   263,   263,   261,   -15,
   -19,   -12,   -16,   -17,   -11,   269,   270,   266,   -20,   272,
   264,   -11,   -13,   271 };
int yydef[]={

     3,    -2,    10,     1,     2,     8,     9,    11,     0,     5,
     6,     0,    -2,     0,     7,     0,     0,     0,    19,    14,
    27,     0,     0,    18,    24,    30,     4,    12,    16,    22,
     0,    19,    20,    23,    21,    25,    26,    28,    29,    31,
     0,    33,    17,    32 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"TOKEN",	257,
	"INT",	258,
	"FLOAT",	259,
	"CHAR",	260,
	"BAR",	261,
	"EQUALS",	262,
	"SEMI",	263,
	"DOLLAR",	264,
	"LBRACE",	265,
	"RBRACE",	266,
	"COLON",	267,
	"STAR",	268,
	"IDENT",	269,
	"PATTERN",	270,
	"INTEGER",	271,
	"CTOKEN",	272,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"grammar : tokendefs productions",
	"tokendefs : tokendefs tokendef",
	"tokendefs : /* empty */",
	"tokendef : TOKEN type IDENT EQUALS PATTERN SEMI",
	"type : INT",
	"type : FLOAT",
	"type : CHAR STAR",
	"type : /* empty */",
	"productions : productions production",
	"productions : /* empty */",
	"production : IDENT",
	"production : IDENT mainclass COLON alternatives SEMI",
	"mainclass : /* empty */",
	"mainclass : ccode",
	"mainclass : /* empty */",
	"alternatives : alternatives BAR",
	"alternatives : alternatives BAR alternative",
	"alternatives : alternative",
	"alternative : /* empty */",
	"alternative : items foobargle",
	"foobargle : ccode",
	"foobargle : /* empty */",
	"items : items item",
	"items : /* empty */",
	"item : IDENT",
	"item : PATTERN",
	"ccode : LBRACE",
	"ccode : LBRACE citems RBRACE",
	"citems : citems citem",
	"citems : /* empty */",
	"citem : CTOKEN",
	"citem : DOLLAR INTEGER",
	"citem : ccode",
	"citem : /* empty */",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 4:
# line 46 "parser.y"
{
		int kind = yypvt[-4].i;
		char *type = builtin_type_name[kind];
		char *name = yypvt[-3].s;
		char *pattern = yypvt[-1].s;
		char *member = builtin_union_member[kind];
		fprintf(ytok, "%%token %s\n", name);
		if (type)
			fprintf(ytype, "%%type <%s> %s\n", member, name);
		declare_token(name, kind, type, pattern);
		} break;
case 5:
# line 59 "parser.y"
{yyval.i = intType;} break;
case 6:
# line 60 "parser.y"
{yyval.i = floatType;} break;
case 7:
# line 61 "parser.y"
{yyval.i = stringType;} break;
case 8:
# line 62 "parser.y"
{yyval.i = noType;} break;
case 11:
# line 71 "parser.y"
{
		lhs = yypvt[-0].s;
		alt_counter = 1;
		fprintf(yunion, "\t%s *u_%s;\n", lhs, lhs);
		fprintf(ytype, "%%type <u_%s> %s\n", lhs, lhs);
		fprintf(yprod, "%s :\n", lhs);
		} break;
case 12:
# line 79 "parser.y"
{fprintf(yprod, ";\n");} break;
case 13:
# line 83 "parser.y"
{fprintf(cdecl, "struct %s {\n", lhs);} break;
case 14:
# line 85 "parser.y"
{fprintf(cdecl, "};\n");} break;
case 15:
# line 87 "parser.y"
{fprintf(cdecl, "struct %s {};\n", lhs);} break;
case 16:
# line 91 "parser.y"
{fprintf(yprod, "|\n");} break;
case 19:
# line 96 "parser.y"
{
		fprintf(cdecl, "struct %s_%d : public %s {\n", 
		lhs, alt_counter, lhs);
		item_counter = 1;
		} break;
case 20:
# line 101 "parser.y"
{
		int i;
		fprintf(yprod, "\t\t{\n");
		fprintf(yprod, 
			"\t\t%s_%d *yynode = new %s_%d;\n", 
				lhs, alt_counter, lhs, alt_counter);
		for (i = 1; i < item_counter; i++)
			if (member_flag[i]) fprintf(yprod, 
				"\t\tyynode->yyval%d = $%d;\n", i, i);
		fprintf(yprod, "\t\t$$ = yynode;\n");
		fprintf(yprod, "\t\t}\n");
		fprintf(cdecl, "};\n");
		++alt_counter;
		} break;
case 25:
# line 126 "parser.y"
{
		char *name = yypvt[-0].s;
		char *type;
		if (!find_token_by_name(name)) { /* nonterminal */
			type = yypvt[-0].s;
			fprintf(cdecl, "\t%s *yyval%d;\n", type, item_counter);
			member_flag[item_counter] = 1;
			}
		else if (type = token_name_to_token_type(name)) { 
			/* token with a value */
			fprintf(cdecl, "\t%s yyval%d;\n", type, item_counter);
			member_flag[item_counter] = 1;
			}
		else {
			/* else token with no value */
			member_flag[item_counter] = 0;
			}
		fprintf(yprod, "%s ", name);
		++item_counter;
		} break;
case 26:
# line 146 "parser.y"
{
		char *pat = yypvt[-0].s;
		char *name = pattern_to_token_name(pat);
		char *type = token_name_to_token_type(name); 
		fprintf(yprod, "%s ", name);
		if (type)
			fprintf(cdecl, "\t%s yyval%d;\n", type, item_counter);
		++item_counter;
		} break;
case 27:
# line 157 "parser.y"
{fputc('{', cdecl);} break;
case 28:
# line 159 "parser.y"
{fputc('}', cdecl);} break;
case 31:
# line 166 "parser.y"
{fputs(yypvt[-0].s, cdecl);} break;
case 32:
# line 167 "parser.y"
{fprintf(cdecl, "yyval%d", yypvt[-0].i);} break;
	}
	goto yystack;		/* reset registers in driver code */
}
