struct yynode {
	char *yysource;
	int yyline;
	yynode();
};

#line 18 "test.y++"
struct expr : yynode {

  ExprType type;
  virtual void TypeCheck() {}
  virtual int IntValue() {return 0;}
  virtual char *StrValue() {return 0;}

  void main() {
    TypeCheck();
    switch (type) {
    case intType:
      printf("The value is: %d\n", IntValue());
      break;
    case strType:
      printf("The value is: \"%s\"\n", StrValue());
      break;
    }
  }

  void TypeMismatch() {
    fprintf(stderr, "%s, line %d: type mismatch\n", yysource, yyline);
    exit(1);
  }

#line 40 "test.y++"
};

#line 97 "test.y++"
struct constant : yynode {

  ExprType type;

  virtual void TypeCheck() {}
  virtual int IntValue() {return 0;}
  virtual char *StrValue() {return 0;}

#line 103 "test.y++"
};
struct yyresult {
  char *message;
  char *source;
  int line;
  int col;
  char *token;
};
expr *ParseExpr(class istream &s, yyresult &r, char *source = 0);
